:
# RCSid:
#	$Id: runas.sh,v 1.2 2022/05/21 04:42:12 sjg Exp $
#
#	@(#) Copyright (c) 1994,2013 Simon J. Gerraty
#
#	This file is provided in the hope that it will
#	be of use.  There is absolutely NO WARRANTY.
#	Permission to copy, redistribute or otherwise
#	use this file is hereby granted provided that 
#	the above copyright notice and this notice are
#	left intact. 
#      
#	Please send copies of changes and bug-fixes to:
#	sjg@crufty.net
#

# these are from rc.sh, but others can use them too.
Which() {
	case "$1" in
	-*) t=$1; shift;;
	*) t=-x;;
	esac
	case "$1" in
	/*)	test $t $1 && echo $1;;
	*)
		for d in `IFS=:; echo ${2:-$PATH}`
		do
			test $t $d/$1 && { echo $d/$1; break; }
		done
		;;
	esac
}

RunAs() {
	_user=$1; shift

	RUNAS=${RUNAS:-`Which runas`}

	if [ -w / ]; then
		_sudo=
	else
		_sudo=${SUDO:-`Which sudo`}
		if [ -z "$_sudo" ]; then
			echo "ERROR: must be 'root'" >&2
			return 1
		fi
	fi
	if [ "$RUNAS" ]; then
		ENV= $_sudo $RUNAS $_user $*
	else
		echo "$*" | ENV= $_sudo ${SU:-su} $_user
	fi
}

case "/$0" in
*/runas*) RunAs "$@";;
esac
